function [corrH, corrV] = gbpTypicalFast4(potH, potV, nIters, nColors)

[n,m]=size(potH);
msgsLR=ones(n+2,m+2);
msgsRL=ones(n+2,m+2);
msgsTB=ones(n+2,m+2);
msgsBT=ones(n+2,m+2);
msgsLRn=ones(n+2,m+2);
msgsRLn=ones(n+2,m+2);
msgsTBn=ones(n+2,m+2);
msgsBTn=ones(n+2,m+2);
potH=padOnes(potH);
potV=padOnes(potV);
q=nColors;
for i=1:nIters, 
   msgsLRn(2:end-1,3:end) = ...
       computeMessages(q, potV(2:end-1,2:end-1).*msgsLR(2:end-1,2:end-1),...   
                          potV(2:end-1,3:end),... 
                          potH(2:end-1,2:end-1).*msgsTB(2:end-1,2:end-1),...   
                          potH(3:end  ,2:end-1).*msgsBT(3:end  ,2:end-1));
                      
   msgsRLn(2:end-1,1:end-2) = ...
       computeMessages(q, potV(2:end-1,2:end-1).*msgsRL(2:end-1,2:end-1),...   
                          potV(2:end-1,1:end-2),... 
                          potH(2:end-1,1:end-2).*msgsTB(2:end-1,1:end-2),...   
                          potH(3:end  ,1:end-2).*msgsBT(3:end,1:end-2));
       
   msgsTBn(3:end,2:end-1) = ...
       computeMessages(q, potH(2:end-1,2:end-1).*msgsTB(2:end-1,2:end-1),...   
                          potH(3:end,2:end-1),... 
                          potV(2:end-1,2:end-1).*msgsLR(2:end-1,2:end-1),...   
                          potV(2:end-1,3:end).*msgsRL(2:end-1,3:end));
                      
   msgsBTn(1:end-2,2:end-1) = ...
       computeMessages(q, potH(2:end-1,2:end-1).*msgsBT(2:end-1,2:end-1),...   
                          potH(1:end-2,2:end-1),... 
                          potV(1:end-2,2:end-1).*msgsLR(1:end-2,2:end-1),...   
                          potV(1:end-2,3:end).*msgsRL(1:end-2,3:end));

   errr = abs(msgsLR-msgsLRn)+abs(msgsRL-msgsRLn)+abs(msgsTB-msgsTBn)+abs(msgsBT-msgsBTn);
   if (sum(errr(:)) < 0.000001)
       break;
   end
   msgsLR=msgsLRn;
   msgsRL=msgsRLn;
   msgsTB=msgsTBn;
   msgsBT=msgsBTn;
end
belV=msgsLR.*msgsRL.*potV;
belV=belV(2:end-1,2:end-1);
belH=msgsTB.*msgsBT.*potH;
belH=belH(2:end-1,2:end-1);

corrH = 1./(1+(q-1)*belH);
corrV = 1./(1+(q-1)*belV);



